<script setup lang="ts">
import { reactive, ref, watch } from "vue";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import type { UserOut } from "@/client/types.gen";
import { useUserStore } from "@/stores/users";

const props = defineProps<{
  modalId: string;
  backModalId?: string;
  filterUserSelf?: boolean;
}>();
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

const store = useUserStore();
const textInputElement = ref<HTMLInputElement | undefined>(undefined);

const formState = reactive<{
  searchString: string;
  potentialUsers: UserOut[];
  lastSearchTimerId: ReturnType<typeof setTimeout> | null;
  error: boolean;
  loading: boolean;
}>({
  searchString: "",
  potentialUsers: [],
  lastSearchTimerId: null,
  error: false,
  loading: false,
});

watch(
  () => formState.searchString,
  (newName) => {
    if (formState.lastSearchTimerId !== null) {
      clearTimeout(formState.lastSearchTimerId);
    }
    if (newName.length > 2) {
      formState.loading = true;
      formState.lastSearchTimerId = setTimeout(searchUser, 500, newName);
    } else {
      formState.loading = false;
      formState.potentialUsers = [];
    }
  },
);

const emit = defineEmits<{
  (e: "user-found", user: UserOut): void;
}>();

function modalClosed() {
  formState.searchString = "";
  formState.potentialUsers = [];
}

function modalShown() {
  textInputElement.value?.focus();
}

function searchUser(name: string) {
  formState.error = false;
  store
    .searchUser(name)
    .then((userSuggestions) => {
      if (props.filterUserSelf) {
        formState.potentialUsers = userSuggestions.filter(
          (user) => store.currentUID != user.uid,
        );
      } else {
        formState.potentialUsers = userSuggestions;
      }
    })
    .catch((err) => {
      formState.error = true;
      console.error(err);
    })
    .finally(() => {
      formState.loading = false;
    });
}
</script>

<template>
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    modal-label="Search User Modal"
    v-on="{ 'hidden.bs.modal': modalClosed, 'shown.bs.modal': modalShown }"
  >
    <template #header>Search User</template>
    <template #body>
      <div class="input-group mt-2 mb-4">
        <span id="objects-search-wrapping" class="input-group-text"
          ><font-awesome-icon icon="fa-solid fa-magnifying-glass"
        /></span>
        <input
          :id="'searchUserInput' + randomIDSuffix"
          ref="textInputElement"
          v-model.trim="formState.searchString"
          class="form-control"
          placeholder="Search for a user"
        />
      </div>
      <div v-if="formState.loading" class="text-center">
        <div class="spinner-border">
          <span class="visually-hidden">Loading...</span>
        </div>
      </div>
      <div v-else-if="formState.error" class="text-center fs-2">
        <font-awesome-icon
          icon="fa-solid fa-x"
          class="mb-2"
          style="color: var(--bs-danger); font-size: 4em"
        />
        <br />
        <span class="text-danger"
          >There seems to be an error<br />Try again later</span
        >
      </div>
      <div v-else-if="formState.potentialUsers.length > 0" class="list-group">
        <button
          v-for="user in formState.potentialUsers"
          :key="user.uid"
          type="button"
          class="list-group-item list-group-item-action"
          :data-bs-target="props.backModalId ? '#' + props.backModalId : null"
          :data-bs-toggle="props.backModalId ? 'modal' : null"
          :data-bs-dismiss="props.backModalId ? null : 'modal'"
          @click="emit('user-found', user)"
        >
          {{ user.display_name }}
        </button>
      </div>
      <div v-else class="text-center fs-2">
        <font-awesome-icon
          icon="fa-solid fa-magnifying-glass"
          class="mb-2"
          style="color: var(--bs-secondary); font-size: 4em"
        />
        <br />
        <span v-if="formState.searchString.length > 2"
          >Could not find any Users</span
        >
        <span v-else>Search for a user</span>
      </div>
    </template>
    <template #footer>
      <button
        v-if="backModalId"
        type="button"
        class="btn btn-secondary"
        :data-bs-target="'#' + props.backModalId"
        data-bs-toggle="modal"
      >
        Back
      </button>
      <button
        v-else
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
      >
        Close
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
